/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/
#ifndef SERVICEWIDGET_H
#define SERVICEWIDGET_H

#include <QWidget>
#include <QLineEdit>
#include <QXmlStreamWriter>

#include <qmobilityglobal.h>

QT_BEGIN_NAMESPACE
class QLabel;
class QComboBox;
QT_END_NAMESPACE

QTM_BEGIN_NAMESPACE
class ServiceMetaDataResults;
QTM_END_NAMESPACE
class InterfacesTabWidget;
class MandatoryLineEdit;
class ErrorCollector;



class ServiceWidget : public QWidget
{
    Q_OBJECT
public:
    ServiceWidget(QWidget *parent = 0);
    void load(const QTM_PREPEND_NAMESPACE(ServiceMetaDataResults) &data);

    void validate(ErrorCollector *errors);
    void writeXml(QXmlStreamWriter *writer) const;

signals:
    void dataChanged();

private slots:
    void setTitle(const QString &text);
    void serviceTypeChanged(int type);

private:
    InterfacesTabWidget *m_ifacesTabs;

    QLabel *m_title;
    MandatoryLineEdit *m_name;
    MandatoryLineEdit *m_path;
    QLineEdit *m_desc;
    QComboBox *m_type;
    QString m_text;
};


#endif

